<!DOCTYPE html>
<html>
  <head>
    <meta charset="utf-8">
    <title>Sandbox Test Code</title>
    <link rel="stylesheet" href="style.css">
  </head>
  <body>
    <div class="navbar">
      <a href="https://pages.gitlab.io/plain-html/">Plain HTML Example</a>
      <a href="https://gitlab.com/pages/plain-html/">Repository</a>
      <a href="https://gitlab.com/pages/">Other Examples</a>
    </div>

    <div id="phaser-example"></div>

    <script src="https://cdnjs.cloudflare.com/ajax/libs/phaser/3.23.0/phaser.min.js" integrity="sha256-4uqhg4Bt90ccgI5D9tA2uhf1lTluFoLkoFSw466fH4s=" crossorigin="anonymous"></script>

    <script src="assets/sprites/adventurer.js"></script>

    <script type="text/javascript" defer>
      var config = {
        width: 800,
        height: 600,
        type: Phaser.AUTO,
        parent: 'phaser-example',
        scene: {
          preload: preload,
          create: create,
          update: update,
        }
      };

      var game = new Phaser.Game(config);
      var player1, player2, player3, player4;

      function preload() {
        adventurerCfg.preload({that:this,name:'adventurer'});
      }

      function create ()
      {
        player1 = this.make.sprite({key:'adventurer',frame:0,x:100,y:50}, true);
        // player2 = this.make.sprite({key:'adventurer',frame:0,x:200,y:50}, true);
        // player3 = this.make.sprite({key:'adventurer',frame:0,x:300,y:50}, true);
        // player4 = this.make.sprite({key:'adventurer',frame:0,x:400,y:50}, true);

        player1.anims.play('idle');

        adventurerCfg.create({that:this,name:'adventurer'})

        player1.setData('xsp', 0.0);  // Momentum (x dimension)
        player1.setData('ysp', 0.0);  // Momentum (y dimension)
        player1.setData('xacc', 0.3);  // Acceleration (walk)
        player1.setData('xdec', 0.6);  // Deceleration (walk)
        player1.setData('yacc', 4.0);  // Acceleration (Jump)
        player1.setData('maxspx', 5.0);  // Maximum speed (walking)
        player1.setData('maxspy', 4.0);  // Maximum acceleration (jump/fall) / terminal velocity

        player1.setData('go_right', false);
        player1.setData('go_left', false);
        player1.setData('go_up', false);
        player1.setData('go_down', false);
        
        // TODO: More animations

        this.input.keyboard.on('keydown-RIGHT', function(event) {
          player1.setData('go_right', true);
        });
        this.input.keyboard.on('keyup-RIGHT', function(event) {
          player1.setData('go_right', false);
        });
        this.input.keyboard.on('keydown-LEFT', function(event) {
          player1.setData('go_left', true);
        });
        this.input.keyboard.on('keyup-LEFT', function(event) {
          player1.setData('go_left', false);
        });
        this.input.keyboard.on('keydown-UP', function(event) {
          player1.setData('go_up', true);
        });
        this.input.keyboard.on('keyup-UP', function(event) {
          player1.setData('go_up', false);
        });
        this.input.keyboard.on('keydown-DOWN', function(event) {
          player1.setData('go_down', true);
        });
        this.input.keyboard.on('keyup-DOWN', function(event) {
          player1.setData('go_down', false);
        });

        // TODO: Jump, Attack, Run?, Controller buttons

      }

      function update() {
        let xsp = player1.getData('xsp');
        let ysp = player1.getData('ysp');

        if(player1.getData('go_right')) { xsp += player1.getData('xacc'); }
        if(player1.getData('go_left')) { xsp -= player1.getData('xacc'); }
        if(!player1.getData('go_right') && !player1.getData('go_left')) {
          xsp *= player1.getData('xdec');
          if(xsp > -1 && xsp < 1) { xsp = 0; }
        }

        if(xsp > player1.getData('maxspx')) { xsp = player1.getData('maxspx'); }
        if(xsp < 0 - player1.getData('maxspx')) { xsp = 0 - player1.getData('maxspx'); }

        player1.setData('xsp', xsp);

        // console.log('xsp:',xsp)

        player1.x += player1.getData('xsp');;
      }
    </script>

  </body>
</html>

